package com.bonus.bracelet.mapper;

import com.bonus.common.entity.bracelet.BraceletParamsDto;
import com.bonus.common.entity.bracelet.vo.*;
import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Map;

/**
 * @className:SidebandMapper
 * @author:cwchen
 * @date:2024-07-16-10:38
 * @version:1.0
 * @description:边带管理-Mapper
 */
@Repository(value = "SidebandMapper")
public interface SidebandMapper {

    /**
     * 班组列表
     *
     * @param data
     * @return List<SidebandVo>
     * @author cwchen
     * @date 2024/7/17 13:51
     */
    List<SidebandVo> getSidebandLists(SidebandVo data);

    /**
     * 杆塔绑定设备列表
     * @param data
     * @return
     */
    List<SidebandDeviceVo> getDeviceLists(SidebandDeviceVo data);

    /**
     * 杆塔绑定设备列表2
     * @param data
     * @return
     */
    List<SidebandDeviceVo> getShLists(SidebandDeviceVo data);

    /**
     * 杆塔未绑定设备列表
     * @param data
     * @return
     */
    List<SidebandDeviceVo> getDeviceNoLists(SidebandDeviceVo data);


    /**
     * 杆塔下拉选
     * @param dto
     * @return AjaxResult
     * @author cwchen
     * @date 2024/7/17 15:58
     */
    List<ProjectPowerVo> getGtList(ProjectPowerVo dto);

    /**
     * 根据边带id获得详细信息
     * @param sidebandId
     * @return
     */
    public SidebandVo selectSidebandById(Integer sidebandId);

    /**
     * 根据工程id查询工程名称
     * @param name
     * @return
     */
    String queryProjectName(String name);

    /**
     * 判断边带名称是否存在
     *
     * @param vo
     * @return int
     * @author cwchen
     * @date 2024/7/17 14:41
     */
    SidebandVo isExist(SidebandVo vo);

    /**
     * 新增时边带名称是否重复
     * @param vo
     * @return
     */
    SidebandVo isNameExist(SidebandVo vo);

    /**
     * 修改边带信息
     * @param vo
     * @return
     */
       int updateSideband(SidebandVo vo);

    /**
     * 新增边带信息
     * @param vo
     * @return
     */
    int addSideband(SidebandVo vo);

    /**
     * 删除边带信息
     * @param vo
     * @return
     */
    int delSideband(SidebandVo vo);

    /**
     * 解除绑定
     * @param vo
     * @return
     */
    int delDevice(SidebandDeviceVo vo);

    /**
     * 解除绑定2
     * @param vo
     * @return
     */
    int delSh(SidebandDeviceVo vo);

    /**
     * 获取人员管理表中领用人名称
     * @param id
     * @return
     */
    String getDeviceLyName(int id);

    /**
     * 获取临时人员管理表中领用人名称
     * @param id
     * @return
     */
    String getDeviceLyNameTemp(int id);

    void bindDevice(@Param("sidebandId") int sidebandId,@Param("deviceId") int deviceId);

    void bindSh(@Param("sidebandId") int sidebandId,@Param("deviceId") int deviceId);

}
